grammar pml2Joc;

@header {	package texToJoc;}

@members{  GestionJoc maGestionJoc;}

@lexer::header {package texToJoc;}

file
   :  enTete listInstruc
   ;
instruc   :  expression	;//| uneFormule   ;
listInstruc   :  (instruc)+   ;

enTete   :  (optionDeTex)?
         ;
//=============== caracteres de base =======================
blanc
   : BLANC { maGestionJoc.blanc(); }
   ;
stca : CARACTERE { maGestionJoc.traiteCaractere($start.getText()); } ;
caractere
   : stca
   ;
caractereComplet
   :  caractere | blanc
    ;
//============== basique =======================

chainePure :  	{ maGestionJoc.commenceNouvelleChaine(); }
     				(caractereComplet)+
   ;
chainePolicee
   :  uneOuverturePolice chainePure? uneFermeturePolice
   ;
expressionBase
   : chainePolicee  | uneFormule | typeRetourChariot 
  // | blanc
   ;

expression	:  contexteTexte 
				;

//===================== contextes ====================================
contexteTexte
   :  CONTEXTE_TEXTE       { maGestionJoc.contexteTexte(); }
      (expressionBase)*
      FIN_CONTEXTE_TEXTE   { maGestionJoc.finContexteTexte(); }
   ;

//================= option TeX et couleurs ===============
optionDeTex :  optionPlain | optionAMS | optionLatex  ;

optionPlain :  OPTION_PLAIN   { maGestionJoc.optionPlain(); }  ;
optionAMS   :  OPTION_AMS     { maGestionJoc.optionAMS(); }  ;
optionLatex :  OPTION_LATEX   { maGestionJoc.optionLaTeX(); }  ;

//======================== Singletons ==============================
typeRetourChariot
   :  TYPE_RETOUR_CHARIOT
            { maGestionJoc.typeRetourChariot(); }
   ;
//===================== tableau ======================



//===================== contextes theoremes ============
//======================== polices Familles =================
taillePolice   : chainePure QUEUE_POLICE
                              { maGestionJoc.queuePolice(); } ;

uneOuverturePolice
   :  ouvertureRomane  | ouvertureItalienne
   ;

ouvertureRomane
   :  policeRoman | romanSlanted | romanBold | romanSlantedBold ;
policeRoman       :  ROMAN_TEX taillePolice ;
romanSlanted      :  SLANTED_TEX taillePolice ;
romanBold         :  BOLDFACE_TEX taillePolice ;
romanSlantedBold  : SLANTED_BOLDFACE_TEX taillePolice ;

ouvertureItalienne
   : policeItalic | italicSlanted | italicBold | italicSlantedBold ;
policeItalic      :  ITALIC_TEX taillePolice ;
italicSlanted     :  ITALIC_SLANTED_TEX taillePolice ;
italicBold        :  ITALIC_BOLDFACE_TEX taillePolice ;
italicSlantedBold :  ITALIC_SLANTED_BOLDFACE_TEX taillePolice ;


/*ouvertureCy
   :  policeCy | cySlanted | cyBold | cySlantedBold  ;
policeCy        :  CYRILLIC_TEX                   taillePolice;
cySlanted       :  CYRILLIC_SLANTED_TEX           taillePolice;
cyBold          :  CYRILLIC_BOLDFACE_TEX          taillePolice;
cySlantedBold   :  CYRILLIC_SLANTED_BOLDFACE_TEX  taillePolice;
*/

//===================== fermetures polices =============================

uneFermeturePolice
   :  fermetureRomane  | fermetureItalienne 
   ;
fermetureRomane
   : finPoliceRoman | finRomanSlanted | finRomanBold | finRomanSlantedBold ;
finPoliceRoman    :  FIN_ROMAN_TEX     { maGestionJoc.policeRoman(0); }
                     taillePolice ;
finRomanSlanted   :  FIN_SLANTED_TEX   { maGestionJoc.policeRoman(1); }
                     taillePolice ;
finRomanBold   :  FIN_BOLDFACE_TEX     { maGestionJoc.policeRoman(2); }
                     taillePolice ;
finRomanSlantedBold : FIN_SLANTED_BOLDFACE_TEX
                                    { maGestionJoc.policeRoman(3); }
                      taillePolice ;

fermetureItalienne
 : finPoliceItalic | finItalicSlanted | finItalicBold | finItalicSlantedBold
 ;
finPoliceItalic   :  FIN_ITALIC_TEX    { maGestionJoc.policeItalic(0); }
                     taillePolice ;
finItalicSlanted : FIN_ITALIC_SLANTED_TEX { maGestionJoc.policeItalic(1);; }
                   taillePolice ;
finItalicBold : FIN_ITALIC_BOLDFACE_TEX  { maGestionJoc.policeItalic(2); }
                taillePolice ;
finItalicSlantedBold : FIN_ITALIC_SLANTED_BOLDFACE_TEX
                                    { maGestionJoc.policeItalic(3); }
                       taillePolice ;


//======================== formules ==============================
//======================== formules ==============================
//======================== formules ==============================
//======================== formules ==============================
//======================== formules ==============================
uneFormule
   :  entreeFormule
      expressionMath
      finFormule
   ;
//========================= genres Formules =============
entreeFormule
   :   petiteFormule 
   ;
petiteFormule
   :  GENRE_LA_PETITE_FORMULE         { maGestionJoc.petiteFormule(); }
   ;
finFormule
   :  FIN_FORMULE                { maGestionJoc.finGenreFormule(); }
   ;
//=============== base maths=======================

basiqueMath
   :  chainePolicee | lesSymboles 
   ;
expressionMath
   :  (basiqueMath)*
   ;
//=========== divers ======

//======================== symboles ==============================
lesSymboles
   :   lesTrios 
   ;
//=================== monos ================
//===============


//=================== trios ===============
lesTrios
   :  integrale 
   ;
//============
entreeBorneInf :  TYPE_BORNE_INF
                     { maGestionJoc.entreeBorneInf(); }
               ;
entreeBorneSup :  TYPE_BORNE_SUP
                     { maGestionJoc.entreeBorneSup(); }
               ;
entreeBorneCor :  TYPE_BORNE_COR
                     { maGestionJoc.entreeBorneCor(); }
               ;
entreeBorneFin	:	TYPE_BORNE_FIN
					;
finTrio
: FIN_INTEGRALE 
                     { maGestionJoc.finTrio(); }
;
leTriCorps
   :  (entreeBorneInf expressionMath)?
      (entreeBorneSup expressionMath)?
      (entreeBorneCor expressionMath)?
      finalMath
   ;
finalMath
   :   finTrio
   ;

//================

entreeIntegrale
   : INTEGRALE 
         { maGestionJoc.entreeIntegrale(); }
   ;
integrale
   :  entreeIntegrale
      leTriCorps
   ;

//======================= le Header =======================================
//======================= sections =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================


//============== couleurs ============================
DEBUT_COULEURS    :  '<rgb(' ;
//============== fin couleurs ============================
FIN_COULEURS         :  ')/>'     ;
//==================
OPTION_PLAIN   :  '<PXplainTexOption>' ;
OPTION_AMS     :  '<PXAMSTexOption>'   ;
OPTION_LATEX   :  '<PXlaTexOption>'    ;
//=============== genre ... =========================================
//=============== fin genre ... =========================================
//==== mode formule ========
GENRE_LA_PETITE_FORMULE          :  '<formula>'     ;
//==== fin mode formule ========
FIN_FORMULE                      :  '<endFormula>'   ;

GENRE_GRAPHIC                    :  '<graphic>'  ;
FIN_GENRE_GRAPHIC                :  '</graphic>' ;
//===================== contextes ====================================
CONTEXTE_TEXTE :  '<simpleText>' ;

FIN_CONTEXTE_TEXTE :  '</simpleText>' ;

//======================== attributs ==============================

//======================== polices =================
ROMAN_TEX               :  '<rm('  ;
SLANTED_TEX             :  '<rmS(' ;
BOLDFACE_TEX            :  '<rmB(' ;
SLANTED_BOLDFACE_TEX    :  '<rmSB(' ;

ITALIC_TEX                    :  '<it(' ;
ITALIC_SLANTED_TEX            :  '<itS(' ;
ITALIC_BOLDFACE_TEX           :  '<itB(' ;
ITALIC_SLANTED_BOLDFACE_TEX   :  '<itSB(' ;


QUEUE_POLICE                  :  ')font>' ;
//DETROMP_QUEUE_POLICE          :  ')fon>' ;
//======================== fin polices =================
FIN_ROMAN_TEX                    :  '</rm(' ;
FIN_SLANTED_TEX                  :  '</rmS(' ;
FIN_BOLDFACE_TEX                 :  '</rmB(' ;
FIN_SLANTED_BOLDFACE_TEX         :  '</rmSB(' ;

FIN_ITALIC_TEX                    :  '</it(' ;
FIN_ITALIC_SLANTED_TEX            :  '</itS(' ;
FIN_ITALIC_BOLDFACE_TEX           :  '</itB(' ;
FIN_ITALIC_SLANTED_BOLDFACE_TEX   :  '</itSB(' ;


//======================== types ==============================
//=== les symboles ===================
INTEGRALE         :  '<int>'          ;

//=== fin les symboles ===================
FIN_INTEGRALE         :  '</int>'          ;

//================== en relation avec les formules
TYPE_BORNE_INF    :  '<lowlimit>'           ;
TYPE_BORNE_SUP    :  '<uplimit>'           ;
TYPE_BORNE_COR    :  '<inlimit>'           ;
TYPE_BORNE_FIN		:	'<inFin>'				;
//==================== en relation avec les RC
TYPE_RETOUR_CHARIOT           :  '<caRet>'   ;
//==================== fin en relation avec les RC
FIN_TYPE_RETOUR_CHARIOT          :  '</caRet>'   ;
//============ fin si la police doit etre change ================
//==================== special ================
//  -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'   // Macintosh
      |  '\n'   // Unix (the right way)
         )
      )  { skip(); }
   ;
BLANC :    ' '  ;
CARACTERE
   :  '!' | '\'' | '\''..'[' | ']' | '`'..'z'
   ;


