header {
package texToJoc;
}

class TexText2PmlParser extends Parser;
options {
   k = 1;
}

{  GestionPml maGestionPml;
}

file  : enTete expression
      ;

enTete : (debutDoc)? { maGestionPml.premiereChaine(); } ;
//enTete :  { maGestionPml.premiereChaine(); } ;

debutDoc : DOCUMENT_CLASS { maGestionPml.debutDoc(); }
            expression
            DEBUT_DOCUMENT { maGestionPml.finDebutDoc();  }
         ;
//=================== expression =========
expression
   : (caractereComplet | separateur)+
   ;
//=============== caracteres de base =====
//leRetourTexte  :  LE_RETOUR     { maGestionPml.leRetourTexte(); } ;
blanc          :  BLANC         { maGestionPml.blanc(); } ;
blancForce     : (BLANC_FORCE | ESPACE) { maGestionPml.blancForce(); } ;
//======================== separateurs ====================
separateur
   : uneFormule
//   | unSingleton
   ;
//======================== caracteres =====================
caractere
   : (st : CARACTERE { maGestionPml.caractere(st.getText()); } )
   ;
caractereAccentue
   : (st : CARACTERE_ACCENTUE
               { maGestionPml.caractereAccentue(st.getText()); } )
   ;
caractereSimple
   : blanc | blancForce
   | caractere | caractereAccentue
   | lettreAccentue
   | ressort
   ;
caractereComplet
   :  caractereSimple
   | caracteresMathML
   | lesReferences
   | changementPermanentDePolice
   | chainePureSoulignee
   | chaineParenthesee
   | item
   | lesReserves
   | tailleScript
   | listeDeChaines
   | contexteTheoreme
   | policeEmballees
   | leHeader
//   | chaineParagraphee
   | ligneCentree
   | lesSections
   | unSingleton
   | tableau
   ;
//======================== Singletons ==============================
unSingleton
   :  finParagraphe | finDuDocument  //| overline
   ;
finParagraphe : FINPARAG   { maGestionPml.finParagraphe(); } ;

finDuDocument : (LE_END | FIN_DOCUMENT) { maGestionPml.finDuDocument(); } ;
//=== fermeture de groupe: remettre taille normale ===
rAccolade   :  R_ACCOLADE           { maGestionPml.tailleNormale(); }
         ;
//========== ligneCentree =========
ligneCentree : LIGNE_CENTREE  { maGestionPml.ligneCentree(); }
               expression
               rAccolade        { maGestionPml.finLigneCentree(); } ;
//============== chaine basique =======================
chaineSimple : { maGestionPml.nouvelleChaine(); }
   (caractereSimple)+
   ;
chainePureSoulignee
            :  UNDERLINE L_ACCOLADE
               expression
               rAccolade
               { maGestionPml.chainePureSoulignee(); } ;

chainePure : { maGestionPml.nouvelleChaine(); }
    (caractereComplet)+
   ;
chainePenchee  : (PL_PENCHEE_EMP | L_PENCHEE_EMP)
                                       { maGestionPml.debChaineFormee(); }
                  expression rAccolade { maGestionPml.chainePenchee(); } ;
chaineGraissee :
         (PL_GRASSE_EMP | L_GRASSE_EMP)
                              { maGestionPml.debChaineFormee(); }
         expression rAccolade { maGestionPml.chaineGraissee(); } ;
/*==
chaineGraisseeFormee
 : (L_GRASSE_PENCHEE_EMP | PL_GRASSE_PENCHEE_EMP)
                              { maGestionPml.debChaineFormee(); }
         expression rAccolade rAccolade
                  { maGestionPml.chaineFormeeGraissee(); } ;
chaineFormeeGraissee
 : (L_PENCHEE_GRASSE_EMP | PL_PENCHEE_GRASSE_EMP)
                           { maGestionPml.debChaineFormee(); }
         expression rAccolade rAccolade
                           { maGestionPml.chaineFormeeGraissee(); }
   ;
==*/
listeDeChaines
 : chainePenchee | chaineGraissee
// | chaineGraisseeFormee | chaineFormeeGraissee
 ;
expressionPureParenthesee :  L_ACCOLADE expression rAccolade ;
chaineParenthesee :  { maGestionPml.chaineParentheseeEntree(); }
                     L_ACCOLADE expression rAccolade
                     { maGestionPml.chaineParenthesee(); } ;
//============== polices =================

policeEmballees
   : unePureOuverturePolice
      (caractereComplet | separateur)+
      rAccolade { maGestionPml.chainePurePoliceeEmpilee(); }
   ;


unePureOuverturePolice
   : (PL_ROMAN_EMP    | L_ROMAN_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.ROMAN); }
   | (PL_SMALLCAP_EMP | L_SMALLCAP_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.SMALLCAP); }
   | (PL_BLACKBOARD_EMP | L_BLACKBOARD_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.BLACKBOARD); }
   | (PL_ITALIC_EMP  | L_ITALIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.ITALIC); }
   | (PL_GOTHIC_EMP  | L_GOTHIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.GOTHIC); }
   | (PL_CALLIGRAPHIC_EMP | L_CALLIGRAPHIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
   | (PL_TYPEWRITER_EMP | L_TYPEWRITER_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.TYPEWRITER); }
   | CYRILLIC_EMP
         { maGestionPml.unePureOuverturePolice(Globale.CYRILLIC); }
   ;
//======================= permanente ===========================
changementPermanentDePolice
   :  changementRoman | changementAutres
   ;

changementRoman
   :  roman | romanSlanted | romanBold
   | romanSlantedBold ;
roman            : ROMAN                { maGestionPml.roman(0); } ;
romanSlanted     : SLANTED_TEX          { maGestionPml.roman(1); } ;
romanBold        : BOLDFACE_TEX         { maGestionPml.roman(2); } ;
romanSlantedBold : SLANTED_BOLDFACE_TEX { maGestionPml.roman(3); } ;

changementAutres
   : blackBoard | italic | gothic | callig | typeWriter
   | smallCap   | cyrillic
   ;
blackBoard  : BLACKBOARD         { maGestionPml.blackBoard(); } ;
italic      : ITALIC             { maGestionPml.italic(); } ;
gothic      : GOTHIC             { maGestionPml.gothic(); } ;
callig      : CALLIGRAPHIC       { maGestionPml.callig(); } ;
typeWriter  : TYPEWRITER         { maGestionPml.typeWriter(); } ;
smallCap    : SMALLCAP           { maGestionPml.smallCap(); } ;
cyrillic    : CYRILLIC           { maGestionPml.cyrillic(); } ;
tailleScript   :  TAILLE_SCRIPT  { maGestionPml.tailleScript(); } ;
//================ divers ============

//==================== reserves ===
lesReserves : accOuvrReserve | accFermReserve | pourcentage | leDieze ;
accOuvrReserve
   :  ACC_OUVRANTE_RESERVE { maGestionPml.lettreReserve('{'); } ;
accFermReserve
   :  ACC_FERMANTE_RESERVE { maGestionPml.lettreReserve('}'); } ;
pourcentage
   :  POUR_CENT { maGestionPml.lettreReserve('%'); } ;
leDieze
   :  LE_DIEZE  { maGestionPml.lettreReserve('#'); } ;

//======================= le header ================================
leHeader : titre | auteur | date ;     // | sommaire ;

titre    :  LE_TITRE
            (caractereComplet)+ rAccolade
            { maGestionPml.titre(); } ;
auteur   :  L_AUTEUR
            (caractereComplet)+ rAccolade
            { maGestionPml.auteur(); } ;
date     :  LA_DATE
            (caractereComplet)+ rAccolade
            { maGestionPml.date(); } ;
/*
resume     :   RESUME                  { maGestionPml.resume(); }
               L_ACCOLADE listExpressions rAccolade
               FIN_RESUME              { maGestionPml.finResume(); } ;
*/
// sommaire   : LE_SOMMAIRE               { maGestionPml.sommaire(); } ;

//======================= theoreme ==============================
intitule
   : LE_BEGIN_PAR chainePure rAccolade { maGestionPml.intitule(); } ;
finIntitule
   : LE_END_PAR chainePure rAccolade { maGestionPml.finIntitule(); } ;
contexteTheoreme
 :    intitule
      expression
      finIntitule ;
//======================= sections =======================================
lesSections : chapitre | paragraphe | sousParagraphe
            | sousSousParagraphe ;

chapitre
:  LE_CHAPITRE   { maGestionPml.chapitre(); }
//   L_ACCOLADE
      expression //     (caractereComplet)+
            rAccolade { maGestionPml.finSections(Globale.PAR_CHAPITRE); }
;
paragraphe
:  LA_SECTION  { maGestionPml.paragraphe(); }
   expression rAccolade
    { maGestionPml.finSections(Globale.PAR_PARAGRAPHE); }
;
sousParagraphe
:  LA_SSECTION { maGestionPml.sousParagraphe(); }
    expression  rAccolade
       { maGestionPml.finSections(Globale.PAR_SS_PARAGRAPHE); } ;
sousSousParagraphe
:  LA_SSSECTION { maGestionPml.sousSousParagraphe(); }
   expression rAccolade
       { maGestionPml.finSections(Globale.PAR_SS_SS_PARAGRAPHE); } ;

//======================= references =======================================
lesReferences
   :  reference | citation | label | source  ;

reference   :  { maGestionPml.avantUneReference(); } REF
               expression
               rAccolade     { maGestionPml.reference(); } ;
citation    :  { maGestionPml.avantUneReference(); } CITE
               expression
               rAccolade      { maGestionPml.citation(); } ;
label       :  { maGestionPml.avantUneReference(); } LABEL
               expression
               rAccolade         { maGestionPml.label(); } ;
source      :  { maGestionPml.avantUneReference(); } SOURCE
               expression
               rAccolade        { maGestionPml.source(); } ;
//======================= listes ============================
//lesListes : listeNumerotee | listeItemisee;
/*
listeNumerotee :  LISTE_NUMEROTEE
                  listExpressions
                  FIN_LISTE_NUMEROTEE  ;
listeItemisee :   LISTE_ITEMISE
                  listExpressions
                  FIN_LISTE_ITEMISE  ;
*/
item : ITEM ;
//========= separateurs ===========
ressort  :  RESSORT           { maGestionPml.ressort(); } ;

overline :  OVERLINE                   { maGestionPml.overline(); }
            expressionPureParenthesee
                                       { maGestionPml.finOverline(); };
//================ tableaux ===========
tableau  :  TABLEAU { maGestionPml.tableau(); }
//            L_ACCOLADE  { maGestionPml.nePasEcrire = true; }
  //          expression
    //        R_ACCOLADE  { maGestionPml.nePasEcrire = false; }
            expression
            (ligneTableau)+
            finTableau
         ;
entreeTableau : esperlueteTableau expression ;
ligneTableau : (entreeTableau)*
               CE_ERRE { maGestionPml.finItemTableau(); }
               ( { maGestionPml.finLigneTableau(); } expression)?
             ;

finTableau :  FIN_TABLEAU  { maGestionPml.finTableau(); } ;
esperlueteTableau :  ESPERLUETE  { maGestionPml.esperlueteTableau(); } ;
finLigneTableau   :  FIN_LIGNE_CR { maGestionPml.finLigneTableau(); } ;
//=================== raccourcis ===========
lesRaccourcis
   :  limite
   ;
limite         : LIMITE {maGestionPml.ecritLimite(); } ;
//=== lettres accentues ==
lettreAccentue :  A_GRAVE         { maGestionPml.lettreAccentue('\u00E0'); }
               | A_AIGU          { maGestionPml.lettreAccentue('\u00E1'); }
               | A_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00E2'); }
               | A_TILDE         { maGestionPml.lettreAccentue('\u00E3'); }
               | A_TREMA         { maGestionPml.lettreAccentue('\u00E4'); }
               | A_ROND          { maGestionPml.lettreAccentue('\u00E5'); }

               | E_GRAVE         { maGestionPml.lettreAccentue('\u00E8'); }
               | E_AIGU          { maGestionPml.lettreAccentue('\u00E9'); }
               | E_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00EA'); }
               | E_TREMA         { maGestionPml.lettreAccentue('\u00EB'); }

               | I_GRAVE         { maGestionPml.lettreAccentue('\u00EC'); }
               | I_AIGU          { maGestionPml.lettreAccentue('\u00ED'); }
               | (I_CIRCONFLEXE |
                  I_CIRCONFLEXE_PAR) { maGestionPml.lettreAccentue('\u00EE'); }
               | I_TREMA         { maGestionPml.lettreAccentue('\u00EF'); }

               | O_GRAVE         { maGestionPml.lettreAccentue('\u00F2'); }
               | O_AIGU          { maGestionPml.lettreAccentue('\u00F3'); }
               | O_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00F4'); }
               | O_TILDE         { maGestionPml.lettreAccentue('\u00F5'); }
               | O_TREMA         { maGestionPml.lettreAccentue('\u00F6'); }

               | U_GRAVE         { maGestionPml.lettreAccentue('\u00F9'); }
               | U_AIGU          { maGestionPml.lettreAccentue('\u00FA'); }
               | U_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00FB'); }
               | U_TREMA         { maGestionPml.lettreAccentue('\u00FC'); }

               | C_CEDILLE       { maGestionPml.lettreAccentue('\u00E7'); }
               | N_TILDE         { maGestionPml.lettreAccentue('\u00F1'); }

               | AM_GRAVE         { maGestionPml.lettreAccentue('\u00C0'); }
               | AM_AIGU          { maGestionPml.lettreAccentue('\u00C1'); }
               | AM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00C2'); }
               | AM_TILDE         { maGestionPml.lettreAccentue('\u00C3'); }
               | AM_TREMA         { maGestionPml.lettreAccentue('\u00C4'); }
               | AM_ROND          { maGestionPml.lettreAccentue('\u00C5'); }

               | EM_GRAVE         { maGestionPml.lettreAccentue('\u00C8'); }
               | EM_AIGU          { maGestionPml.lettreAccentue('\u00C9'); }
               | EM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CA'); }
               | EM_TREMA         { maGestionPml.lettreAccentue('\u00CB'); }

               | IM_GRAVE         { maGestionPml.lettreAccentue('\u00CC'); }
               | IM_AIGU          { maGestionPml.lettreAccentue('\u00CD'); }
               | IM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CE'); }
               | IM_TREMA         { maGestionPml.lettreAccentue('\u00CF'); }

               | OM_GRAVE         { maGestionPml.lettreAccentue('\u00D2'); }
               | OM_AIGU          { maGestionPml.lettreAccentue('\u00D3'); }
               | OM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00D4'); }
               | OM_TILDE         { maGestionPml.lettreAccentue('\u00D5'); }
               | OM_TREMA         { maGestionPml.lettreAccentue('\u00D6'); }

               | UM_GRAVE         { maGestionPml.lettreAccentue('\u00D9'); }
               | UM_AIGU          { maGestionPml.lettreAccentue('\u00DA'); }
               | UM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00DB'); }
               | UM_TREMA         { maGestionPml.lettreAccentue('\u00DC'); }

               | CM_CEDILLE       { maGestionPml.lettreAccentue('\u00C7'); }
               | NM_TILDE         { maGestionPml.lettreAccentue('\u00D1'); }
//=== speciales ===
               | LE_MOINS         { maGestionPml.lettreAccentue('-'); }
               ;
caracteresMathML : inferieur | superieur | lOblique
                 ;
inferieur   :  INFERIEUR   { maGestionPml.caracteresMathML('<'); } ;
superieur   :  SUPERIEUR   { maGestionPml.caracteresMathML('>'); } ;
lOblique    :  L_OBLIQUE   { maGestionPml.caracteresMathML('/'); } ;
//========================= genres Formules =============
uneFormule  : petiteFormule | formuleBegin | formuleStandard
            ;
petiteFormule
   :  PETITE_FORMULE { maGestionPml.petiteFormule(); }
      expression
      FIN_PETITE_FORMULE { maGestionPml.finPetiteFormule(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
formuleStandard
   :  FORMULE_STANDARD { maGestionPml.formuleStandard(); }
      expression
      FIN_FORMULE_STANDARD { maGestionPml.finFormuleStandard(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
formuleBegin
   :  FORMULE_BEGIN          { maGestionPml.formuleBegin(); }
      expression
      FIN_FORMULE_BEGIN { maGestionPml.finFormuleBegin(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
finFor   :  FIN_FOR ;
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================

class TexText2PmlLexer extends Lexer;
options {
   k = 25;
    charVocabulary = '\u0000'..'\u00FF';
//	charVocabulary = '\3'..'\177';
}
{  boolean enPf = false;
}

//======== mots reserves par TeX ==========
DEBUT_DOCUMENT  : "\\begin{document}"  ;
FIN_DOCUMENT    : "\\end{document}"  ;
LE_END          : "\\end"  ;

TABLEAU     :  "\\begin{tabular}"   ;
FIN_TABLEAU :  "\\end{tabular}"     ;
ESPERLUETE  :  "\\esperluete"       ;

LE_BEGIN_PAR    :	"\\begin{"  ;
LE_END_PAR      :	"\\end{"    ;

R_ACCOLADE     :  "}"    { if(enPf) $setType(CARACTERE); }  ;
L_ACCOLADE     :  "{"    { if(enPf) $setType(CARACTERE); }  ;

RESSORT     :  "\\hfill"   ;

//=== caracteres particuliers =============
LIGNE_CENTREE  :  "\\centerline{" ;
FINPARAG       :	("\\par "  |  "\\ \\par " | "\\par"  |  "\\ \\par")   ;
ITEM           :	"\\item"        ;
UNDERLINE      :  "\\underbar"
               |  "\\underline"   ;

//=== Latex ===============================

LE_TITRE    :	"\\title{"           ;
L_AUTEUR	   :  "\\author{"          ;
LA_DATE     :	"\\date{"            ;
//RESUME      :  "\\begin{abstract}"  ;
//FIN_RESUME  :  "\\end{abstract}"  ;
// LE_SOMMAIRE :	"\\tableofcontents"  ;

LE_CHAPITRE       :	("\\chapter{" | "\\chapter{ ")               ;
LA_SECTION        :	("\\section{"  | "\\section{ ")              ;
LA_SSECTION       :	("\\subsection{"  | "\\subsection{ ")        ;
LA_SSSECTION      :	("\\subsubsection{"  | "\\subsubsection{ ")  ;

LABEL             :	("\\label{" | "~\\label{")  ;
REF               :	("\\ref{"   | "~\\ref{" )    ;
CITE              :	("\\cite{"  | "~\\cite{")    ;
SOURCE            :	"\\bibitem{"          ;
//==================== formule ============================

PETITE_FORMULE          :  "\\DebPtFor"   {enPf = true;}    ;
FIN_PETITE_FORMULE      :  "\\FinPtFor"   {enPf = false;}   ;

FORMULE_STANDARD        :   "\\DebGdFor"  {enPf = true;}    ;
FIN_FORMULE_STANDARD    :   "\\FinGdFor"  {enPf = false;}   ;

FORMULE_BEGIN           :  "\\DebBgFor"   {enPf = true;}    ;
FIN_FORMULE_BEGIN       :  "\\FinBgFor"   {enPf = false;}   ;

FIN_FOR                 :  "\\finFormule" { if(enPf) $setType(CARACTERE); }  ;
/*
LISTE_NUMEROTEE         :  "\\begin{enumerate}"   ;
FIN_LISTE_NUMEROTEE     :  "\\end{enumerate}"   ;
LISTE_ITEMISE           :  "\\begin{itemize}"   ;
FIN_LISTE_ITEMISE       :  "\\end{itemize}"   ;
*/
OVERLINE          :  "\\overline"      ;

//================ polices permanentes ============

ROMAN          :  "\\rm"   ;
BLACKBOARD     :  "\\Bbb"  ;
ITALIC         :  "\\it"   ;
GOTHIC         :  "\\goth" ;
CALLIGRAPHIC   :  "\\cal"  ;
TYPEWRITER     :  "\\tt"   ;
SMALLCAP       :  ("\\sc" | "\\Ptm")  ;
CYRILLIC       :  "\\cyr"  ;

//============= polices maths permanentes ===========

MATHS         :  "\\mt{"  ;

BATHS         :  "\\mt2{" ;

GRECS         :  "\\gr{"  ;

BBB           :  "\\fbb{" ;

//============= attributs polices  =================
BOLDFACE_TEX   :  "\\bf"      ;
SLANTED_TEX    :  "\\sl"      ;
//============== tailles ===================
TAILLE_SCRIPT  :  "\\scriptstyle" ;

//================ polices math ============
PL_BLACKBOARD_EMP :  "{\\Bbb"    ;
L_BLACKBOARD_EMP  :  "\\textbb{"
                  |  "\\mathbb{"   ;
//================ polices empilees ============
PL_ROMAN_EMP      : "{\\rm"      ;
L_ROMAN_EMP       :  "\\textrm{"
                  |  "\\mathrm{" ;
PL_ITALIC_EMP     :  "{\\it"     ;
L_ITALIC_EMP      :  "\\textit{"
                  |  "\\mathit{" ;
PL_GOTHIC_EMP     :	"{\\goth"   ;
L_GOTHIC_EMP      :  "\\mathfrak{" ;

PL_CALLIGRAPHIC_EMP  :	"{\\cal"      ;
L_CALLIGRAPHIC_EMP   :	"\\mathcal{"      ;

PL_TYPEWRITER_EMP    :	"{\\tt"       ;
L_TYPEWRITER_EMP     :  "\\texttt{"
                     |  "\\mathtt{"       ;
PL_SMALLCAP_EMP   :	"{\\sc"
	               |  "{\\Ptm" ;
L_SMALLCAP_EMP    :  "\\textsc{"
                  |  "\\mathsc{"  ;
CYRILLIC_EMP	   :  "{\\cyr"       ;
//============= formes polices =================
PL_GRASSE_EMP  :  "{\\bf"        ;
L_GRASSE_EMP   :  "\\textbf{"
               |  "\\mathbf{"    ;

PL_PENCHEE_EMP :  "{\\sl"     ;
L_PENCHEE_EMP  :  "\\textsl{"
               |  "\\mathsl{" ;
/*==
L_GRASSE_PENCHEE_EMP   :  "\\textbf{\\textsl{"    ;
L_PENCHEE_GRASSE_EMP   :  "\\textsl{\\textbf{"    ;
PL_GRASSE_PENCHEE_EMP   :  "{\\bf{\\sl "    ;
PL_PENCHEE_GRASSE_EMP   :  "{\\sl{\\bf "    ;
==*/
//=================== lettres accentues ========================
LE_MOINS       :  ("{\\tt -}" | "{\\tt\r\n -}" {newline();}
                   | "{\\tt \r\n-}" {newline();});
A_GRAVE        : "\\`a" ;
A_AIGU         : "\\\'a" ;
A_CIRCONFLEXE  : "\\^a" ;
A_TILDE        : "\\~a" ;
A_TREMA        : "\\\"a" ;
A_ROND         : "\\.a" ;

E_GRAVE        : "\\`e" ;
E_AIGU         : "\\\'e" ;
E_CIRCONFLEXE  : "\\^e" ;
E_TREMA        : "\\\"e" ;

I_GRAVE        : ("\\`i" | "\\`\\i")   ;
I_AIGU         : ("\\\'i" | "\\\'\\i") ;
I_CIRCONFLEXE  : ("\\^i"  | "\\^\\i")  ;
I_CIRCONFLEXE_PAR :  "{\\^\\i}" ;
I_TREMA        : ("\\\"i" | "{\\\"i}" | "\\\"\\i" | "{\\\"\\i}") ;

O_GRAVE        : "\\`o" ;
O_AIGU         : "\\\'o" ;
O_CIRCONFLEXE  : "\\^o" ;
O_TILDE        : "\\~o" ;
O_TREMA        : "\\\"o" ;

U_GRAVE        : "\\`u" ;
U_AIGU         : "\\\'u" ;
U_CIRCONFLEXE  : "\\^u" ;
U_TREMA        : "\\\"u" ;

C_CEDILLE      :  ("\\c c" | "{\\c c}" | "\\c\r\nc" {newline();}) ;
N_TILDE        :  "\\~n" ;

AM_GRAVE        : "\\`A" ;
AM_AIGU         : "\\\'A" ;
AM_CIRCONFLEXE  : "\\^A" ;
AM_TILDE        : "\\~A" ;
AM_TREMA        : "\\\"A" ;
AM_ROND         : "\\.A" ;

EM_GRAVE        : "\\`E" ;
EM_AIGU         : "\\\'E" ;
EM_CIRCONFLEXE  : "\\^E" ;
EM_TREMA        : "\\\"E" ;

IM_GRAVE        : "\\`I" ;
IM_AIGU         : "\\\'I" ;
IM_CIRCONFLEXE  : "\\^I" ;
IM_TREMA        : "\\\"I" ;

OM_GRAVE        : "\\`O" ;
OM_AIGU         : "\\\'O" ;
OM_CIRCONFLEXE  : "\\^O" ;
OM_TILDE        : "\\~O" ;
OM_TREMA        : "\\\"O" ;

UM_GRAVE        : "\\`U" ;
UM_AIGU         : "\\\'U" ;
UM_CIRCONFLEXE  : "\\^U" ;
UM_TREMA        : "\\\"U" ;

CM_CEDILLE      :  "\\c C" ;
NM_TILDE        :  "\\~N" ;
//===================  fin lettres accentues ========================

ACCENT_GRAVE         :  "\\`"    ;
ACCENT_AIGU          :  "\\\'"   ;
ACCENT_CIRCONFLEXE   :  "\\^"    ;
ACCENT_TREMA         :  "\\\""   ;
ACCENT_TILDE         :  "\\~"    ;
ACCENT_CEDILLE       :  "\\c"   ;
ACCENT_POINT_DESSUS  :  "\\."    ;
ACCENT_POINT_DESSOUS :  "\\d"   ;
ACCENT_UMLAUT        :  "\\H"   ;
ACCENT_TCHECHE       :  "\\v"   ;
ACCENT_BARRE_DESSUS  :  "\\="    ;
ACCENT_BARRE_DESSOUS :  "\\b"   ;

//===========
ESPACE            :  ("\\espace" | "\\;");
BACKSLASH         :  "\\backslash" ;
//==================== reserves ================
ACC_OUVRANTE_RESERVE : "\\{" ;
ACC_FERMANTE_RESERVE : "\\}" ;
POUR_CENT            : "\\%" ;
LE_DIEZE             : "\\#" ;
//==================== MathML ================
INFERIEUR      :  "<" ;
SUPERIEUR      :  ">" ;
L_OBLIQUE      :  "/" ;
//===========================
CE_ERRE           :  "\\cr" ;
//========== a virer ========
BLANC_NEGATIF  :  "\\!" ;
//==================== special ================
//LE_RETOUR            :  "\r\n" {newline();} ;

// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  "\r\n" {newline();}   // Evil DOS
      |  '\r' {newline();}     // Macintosh
      |  '\n'  {newline();}  // Unix (the right way)
         )
      )  { _ttype = Token.SKIP; }
   ;

// Single-line comments
SL_COMMENT
	:	"%"
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{$setType(Token.SKIP); }
	;
DOCUMENT_CLASS
   :  "\\documentclass"
   ;
A_REJETER
   :  ( "\\vspace{-\\baselineskip}"
      | "\\maketitle"
      | "\\displaystyle"
      | "$\\square $"
      | "$ \\square $"
      | "\\vfill\\eject"
      | "{\\hskip9pt}" | "{\\hskip15pt}" | "{\\hskip18pt}"
      | "{\\hskip33pt}" | "{\\hskip6pt}" | "{\\hskip24pt}"
      | "{\\hskip30pt}" | "{-\\baselineskip}"
      | "\\begin{enumerate}" | "\\begin{itemize}"
      | "\\end{enumerate}" | "\\end{itemize}" | "\\leftskip"
      | "\\setcounter{equation}{0}"
      | "\\setcounter{equation} {0}"
      | "\\tableofcontents"
      ) { $setType(Token.SKIP); } ;

//BLANC_FORCE :	("\\ "| "\\ \r\n" {newline();} ) { if(!enPf) $setType(Token.SKIP); } ;
BLANC       :  ' ' { if(enPf) $setType(Token.SKIP); } ;

BLANC_FORCE : ("\\ " | "\\," | "\\\r\n" {newline();} );

//CONTRE_OBLIQUE  : "\\\\"  { if(enPf) $setType(CARACTERE); }  ;
CONTRE_OBLIQUE  : '\\'
  { if(enPf)
      throw new SemanticException("En formule, ligne no " + getLine(),
                                       getFilename(), getLine());
   else if(!enPf)
      throw new SemanticException("Hors formule, ligne no " + getLine(),
                                       getFilename(), getLine());
    } ;

CARACTERE
: '&'
| '~'
| '|'
|'_'
|'^'
| '!'
| '\"'
| '\''..'.'
| '0'..';'
| '='
| '?'..'['
| ']'
| '`'..'z' ;

//CARACTERE_RESERVE  :  '&' | '~'  ;
CARACTERE_DIEZE    : '#'  { if(enPf) $setType(CARACTERE); }  ;
// CARACTERE_ACCENTUE :  '\u00A1'..'\u00FF' ;
CARACTERE_ACCENTUE : ~(
'&'
| '~'
| '|'
|'_'
|'^'
| '!'
| '\"'
| '\''..'.'
| '0'..';'
| '='
| '?'..'['
| ']'
| '`'..'z'
| ' '
| '\\'
| '}' | '{' | '>' | '<' | '/' | '\t' | '\n' | '\f' | '\r'
| '#'
) ;
